from collections import deque, defaultdict

def find_guarded_warehouses(n, m, k, roads, guards):
    # Построение графа
    graph = defaultdict(list)
    
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)
    
    # Множество для хранения охраняемых складов
    guarded = set()
    
    # Обход для каждого охранника
    for p, h in guards:
        # BFS для охранника
        queue = deque([(p, 0)])  # (текущий склад, текущая дистанция)
        visited = set()
        visited.add(p)
        
        while queue:
            current, distance = queue.popleft()
            if distance <= h:
                guarded.add(current)  # Добавляем охраняемый склад
                for neighbor in graph[current]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, distance + 1))
    
    # Формирование результата
    guarded_list = sorted(guarded)
    return len(guarded_list), guarded_list

# Чтение входных данных
n, m, k = map(int, input().strip().split())
roads = [tuple(map(int, input().strip().split())) for _ in range(m)]
guards = [tuple(map(int, input().strip().split())) for _ in range(k)]

# Получение охраняемых складов
count, guarded_warehouses = find_guarded_warehouses(n, m, k, roads, guards)

# Вывод результата
print(count)
if count > 0:
    print(' '.join(map(str, guarded_warehouses)))
else:
    print()
