from collections import deque, defaultdict
import sys

input = sys.stdin.read

def find_guarded_warehouses(n, m, k, roads, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)
    guarded_warehouses = set()

    #BFS
    for p, h in guards:
        queue = deque([(p, 0)])
        visited = set([p])

        while queue:
            warehouse, distance = queue.popleft()
            if distance <= h:
                guarded_warehouses.add(warehouse)
            else:
                continue
            for neighbor in graph[warehouse]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, distance + 1))
    guarded_warehouses = sorted(guarded_warehouses)
    print(len(guarded_warehouses))
    print(' '.join(map(str, guarded_warehouses)))
data = input().strip().splitlines()
n, m, k = map(int, data[0].split())
roads = [tuple(map(int, line.split())) for line in data[1:m+1]]
guards = [tuple(map(int, line.split())) for line in data[m+1:m+1+k]]
find_guarded_warehouses(n, m, k, roads, guards)
