from collections import deque, defaultdict

def find_guarded_warehouses(n, m, k, roads, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)
    guarded_warehouses = set()
    for p, h in guards:
        # BFS
        queue = deque([(p, 0)])
        visited = set([p])

        while queue:
            warehouse, distance = queue.popleft()
            if distance <= h:
                guarded_warehouses.add(warehouse)

            for neighbor in graph[warehouse]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, distance + 1))
    guarded_warehouses = sorted(guarded_warehouses)
    print(len(guarded_warehouses))
    print(" ".join(map(str, guarded_warehouses)))
n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
find_guarded_warehouses(n, m, k, roads, guards)
