from collections import deque, defaultdict
def find_guarded_warehouses(n, m, k, roads, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)
    distances = [float('inf')] * (n + 1)
    queue = deque()
    for p, h in guards:
        queue.append((p, 0))
        distances[p] = 0
    while queue:
        warehouse, distance = queue.popleft()
        
        if distance < h:
            for neighbor in graph[warehouse]:
                if distances[neighbor] > distance + 1:
                    distances[neighbor] = distance + 1
                    queue.append((neighbor, distance + 1))
    guarded_warehouses = [i for i in range(1, n + 1) if distances[i] != float('inf')]
    print(len(guarded_warehouses))
    print(" ".join(map(str, sorted(guarded_warehouses))))
n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

find_guarded_warehouses(n, m, k, roads, guards)
